#include <libthrowable.h>
#include <cstdlib>
#include <ctime>
#include <iostream>
using namespace std;
using namespace libthrowable;
namespace {
namespace tags {
	struct MeltdownTag
	{
		static const string& name()
		{
			static const string ret("Meltdown");
			return ret;
		}
	};

	struct CoolingSystemLeakageTag
	{
		static const string& name()
		{
			static const string ret("CoolingSystemLeakage");
			return ret;
		}
	};

	struct MinorOperatingErrorTag
	{
		static const string& name()
		{
			static const string ret("MinorOperatingError");
			return ret;
		}
	};
}

typedef ThrowableType<Error, tags::MeltdownTag> Meltdown;
typedef ThrowableType<Problem, tags::CoolingSystemLeakageTag> CoolingSystemLeakage;
typedef UserFaultType<UserFault, tags::MinorOperatingErrorTag> MinorOperatingError;

void runNuclearReactorForOneYear()
{
	if(rand()%2 == 0)
		throw MinorOperatingError(LIBTHROWABLE_HERE, "Everything is under control!");
	if(rand()%8 == 0)
		throw CoolingSystemLeakage(LIBTHROWABLE_HERE);
	if(rand()%100 == 0)
		throw Meltdown(LIBTHROWABLE_HERE);
}
}

int main()
{
	srand(time(NULL));
	try
	{
		for(unsigned i=0; i != 20; ++i)
		{
			try
			{
				runNuclearReactorForOneYear();
			}
			catch(const UserFault& uf)
			{
				cerr << uf << endl;
			}
			catch(const Problem& pr)
			{
				cerr << pr << endl;
			}
		}
	}
	catch(const Error& err)
	{
		cerr << err << endl;
		return -666;
	}
}
