#include <libthrowable/macros/trace.h>
using libthrowable::util::stringify;

namespace {
class PleaseHelpImBuggy
{
	public:
	PleaseHelpImBuggy()
	{ LIBTHROWABLE_TRACE_WITH_MSG(tp1, "constructing ..."); }

	PleaseHelpImBuggy(const PleaseHelpImBuggy&)
	{ LIBTHROWABLE_TRACE_WITH_MSG(tp1, "copying ..."); }

	PleaseHelpImBuggy& operator=(const PleaseHelpImBuggy&)
	{ LIBTHROWABLE_TRACE_WITH_MSG(tp1, "assigning ...");  return *this; }

	void whatTheHellHappensHere()
	{
		LIBTHROWABLE_TRACE(tp1);
		buggyPrivateMethod();
		LIBTHROWABLE_TRACE(tp2);
	}

	~PleaseHelpImBuggy()
	{ LIBTHROWABLE_TRACE_WITH_MSG(tp1, "destroying ..."); }

	private:
	void buggyPrivateMethod()
	{
		LIBTHROWABLE_TRACE(tp1);
		anotherBuggyAndPrivateMethod();
		LIBTHROWABLE_TRACE(tp2);
	}

	void anotherBuggyAndPrivateMethod()
	{
		LIBTHROWABLE_TRACE_WITH_MSG(tp1, "entering for loop ...");
		for(unsigned i=0; i != 5; ++i)
			LIBTHROWABLE_TRACE_VAR(tp2, i);
		LIBTHROWABLE_TRACE_WITH_MSG(tp3, "left for loop ...");
	}
};
}//local namespace

int main()
{
	LIBTHROWABLE_TRACE(tp1);
	PleaseHelpImBuggy fullOfBugs1;
	PleaseHelpImBuggy fullOfBugs2(fullOfBugs1);
	PleaseHelpImBuggy fullOfBugs3;

	fullOfBugs3 = fullOfBugs1;
	fullOfBugs3.whatTheHellHappensHere();
}
