/* libthrowable - a C++ library to ease error handling and debugging
 *
 * Copyright (C) Matthias Langer 2006 <mlangc@gmx.at>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef H_LIBTHROWABLE_FAILED_ASSERTION
#define H_LIBTHROWABLE_FAILED_ASSERTION
#include "error.h"
namespace libthrowable {
#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace tags {
	struct FailedAssertionTag
	{
		static const std::string& name()
		{
			static const std::string ret("FailedAssertion");
			return ret;
		}
	};
}//namespace tags
#endif

/** This type represents a failed assertion.*/	
typedef ThrowableType<Problem, tags::FailedAssertionTag> FailedAssertion;
}//namespace
#endif

