#ifndef H_LIBTHROWABLE_HERE
#define H_LIBTHROWABLE_HERE

#ifndef LIBTHROWABLE_DISABLE_MACROS
/** Convenience macro.
 * @ingroup various
 * Can be used as follows:
 * @code
 *  ...
 *  catch(const Throable& th)
 *  {
 *		throw Error(LIBTHROWABLE_HERE, th, "damn ...");
 *  }
 *  ...
 * @endcode*/
#if defined __GNUC__
#define LIBTHROWABLE_HERE \
	__FILE__, __LINE__, __PRETTY_FUNCTION__
#elif defined _MSC_VER
#define LIBTHROWABLE_HERE \
	__FILE__, __LINE__, __FUNCSIG__
#else
#define LIBTHROWABLE_HERE \
	__FILE__, __LINE__, __func__
#endif

#endif //LIBTHROWABLE_DISABLE_MACROS

#endif //H_LIBTHROWABLE_HERE



